MODULE Starter 

  INTEGER, PARAMETER :: SP = KIND(1.0) 
  INTEGER, PARAMETER :: DP = KIND(1.0D0) 
  !Frequently used mathematical constants (with precision to spare): 
  REAL(SP), PARAMETER :: PI=3.141592653589793238462643383279502884197_dp 

END MODULE Starter

PROGRAM TEST_ARRAYS
  
  USE starter, ONLY : wp=>dp
  IMPLICIT NONE
  
  INTEGER :: n,m,p
  REAL(wp), ALLOCATABLE :: a(:)
  REAL(wp), ALLOCATABLE :: b(:,:)
  REAL(wp), ALLOCATABLE :: c(:,:,:)
  CHARACTER (LEN=50) :: string,format_label

  PRINT*,'Input size of array dimensions n, m, and p'
  READ(5,*)n,m,p
  
  ALLOCATE(A(n),B(n,m),C(n,m,p))
  
  CALL RANDOM_NUMBER(a)
  CALL RANDOM_NUMBER(b)
  CALL RANDOM_NUMBER(c)
  
  write(string,*)n
  format_label ='('//TRIM(ADJUSTL(string))//'(f10.8,1x))'
  WRITE(6,*)
  OPEN(unit=10,FILE='one_dim_array.dat')
    WRITE(10,*)n
    WRITE(10,format_label)A
  close(unit=10)
  OPEN(unit=10,file='two_dim_array.dat')
    write(10,*)n,m
    WRITE(10,format_label)B
  close(unit=10)
  OPEN(unit=10,file='three_dim_array.dat')
    WRITE(10,*)n,m,p
    WRITE(10,format_label)C
  close(unit=10)

END PROGRAM TEST_ARRAYS
